<template>
    <Base activeIndex="2">
    </Base>
    <div class="container">
        <el-card class="box-card">
            <template #header>
                <div class="card-header">
                    <h1>{{ this.topic }}</h1>
                    <p>状态：<span style="color:green">{{ this.status }}</span></p>
                </div>
            </template>
            <div class="main">
                <el-row class="status">
                    <el-col :span="2">德育分: {{ this.score }}</el-col>
                    <el-col :span="6" :offset="2">活动人数: {{ this.sign_up }}/{{ this.total }}</el-col>
                    <el-col :span="8" :offset="5">活动时间: {{ this.start }}~{{ this.end }}</el-col>
                </el-row>
                <div class="feedback_form">
                    <el-row type="flex" :align="start">
                        <el-col :span="3">
                            <p>地理位置:</p>
                        </el-col>
                        <el-col :span="12" style="text-align:left" :offset="1">
                            <el-button @click="find_position" type="primary">
                                定位
                            </el-button>
                            <span v-if="location">({{ this.lat }},{{ this.lng }}) </span>
                        </el-col>
                    </el-row>
                    <el-row style="padding-top:30px">
                        <el-col :span="3">
                            <p>上传图片:</p>
                        </el-col>
                        <el-col :span="12" style="text-align:left" :offset="1">
                            <a href="" class="picture">上传图片
                                <input type="file" id="file">
                            </a>

                            <!-- <el-upload action="" list-type="picture-card"
                                :on-preview="handlePictureCardPreview" 
                                :on-remove="handleRemove" ref="upload"
                                :http-request="uploadHttpRequest"
                                :auto-upload="false">
                                <i class="fa fa-cloud-upload"></i>
                            </el-upload> -->
                        </el-col>
                        <el-col>
                            <img id="preview" />
                        </el-col>
                    </el-row>
                    <el-row style="padding-top:40px">
                        <el-col :span="3">
                            <p>活动感想:</p>
                        </el-col>
                        <el-col :span="18" style="text-align:left" :offset="1">
                            <el-input type="textarea" :rows="8" placeholder="请输入内容" v-model="textarea">
                            </el-input>
                        </el-col>
                    </el-row>
                </div>

                <el-row>
                    <el-col>
                        <el-button type="success" class="submitBtn" @click="submitForm()"
                            :disabled="this.status != '未审核'">上传反馈</el-button>
                    </el-col>
                </el-row>


            </div>
        </el-card>
    </div>
</template>

<script>
import axios from "axios";
import Base from "./Base.vue";
import global from "./Common.vue";
function getQueryVariable(variable) {
    var query = window.location.search.substring(1);
    var vars = query.split("&");
    for (var i = 0; i < vars.length; i++) {
        var pair = vars[i].split("=");
        if (pair[0] == variable) { return decodeURI(pair[1]); }
    }
    return (false);
}

export default {
    name: "ActivityFeedback",
    data() {
        return {
            id: getQueryVariable("feedback_id"),
            topic: "",
            status: "",
            score: "",
            sign_up: "",
            total: "",
            start: "",
            end: "",
            lat: "",
            lng: "",
            location: false,
            dialogImageUrl: '',
            dialogVisible: false,
            textarea: "",
            ip: global.ip
        }
    },
    created() {
        let token = localStorage.getItem('token');
        axios({
            method: "POST",
            url: "http://" + this.ip + "/api/browse/details/" + this.id,
            headers: { 'Authorization': `Bearer: ${token}` }
        }).then((res) => {
            console.log(res)
            if (res.data.code == '00') {
                this.topic = res.data.activity.topic;
                this.score = res.data.activity.score;
                this.start = res.data.activity.startTime;
                this.end = res.data.activity.endTime;
                this.total = res.data.activity.maximum;
                this.sign_up = res.data.activity.parti_num;
                let states = ['未报名', '未审核', '正在审核', '审核成功', '审核失败'];
                this.status = states[res.data.activity.state + 1];
            }

        })
    },
    components: {
        Base
    },
    methods: {
        // uploadHttpRequest(param){
        //     formData.append('file',param.file);   
        // },
        submitForm() {
            var formData = new FormData();
            formData.append('aid', this.id);
            formData.append('file', document.getElementById('file').files[0]);
            formData.append('location', "(" + this.lat + "," + this.lng + ")");
            formData.append('text', this.textarea);
            let token = localStorage.getItem('token');
            console.log(formData)
            axios({
                method: "POST",
                url: "http://" + this.ip + "/api/manage/actres",
                headers: {
                    'Authorization': `Bearer: ${token}`,
                    'Content-Type': 'multipart/form-data'
                },
                data: formData
            }).then((res) => {
                console.log(res);
                alert(res.data.msg);
                if (res.data.code == '00')
                    window.location.replace("http://" + global.ip_front + "/activities_detailed");
            })
        },
        getLocation() {
            let _that = this;
            const location = {
                initMap(id) {
                    let mapObj = new AMap.Map(id, {})
                    let geolocation;

                    mapObj.plugin(['AMap.Geolocation'], function () {
                        geolocation = new AMap.Geolocation({
                            enableHighAccuracy: true, //  是否使用高精度定位，默认:true
                            timeout: 10000, //  超过10秒后停止定位，默认：无穷大
                            maximumAge: 0, // 定位结果缓存0毫秒，默认：0
                            convert: true, // 自动偏移坐标，偏移后的坐标为高德坐标，默认：true
                            showButton: true, //  显示定位按钮，默认：true
                            buttonPosition: 'LB',  // 定位按钮停靠位置，默认：'LB'，左下角
                            buttonOffset: new AMap.Pixel(10, 20), //  定位按钮与设置的停靠位置的偏移量，默认：Pixel(10, 20)
                            showMarker: true, //  定位成功后在定位到的位置显示点标记，默认：true
                            showCircle: true, //  定位成功后用圆圈表示定位精度范围，默认：true
                            panToLocation: true,  //  定位成功后将定位到的位置作为地图中心点，默认：true
                            zoomToAccuracy: true  //  定位成功后调整地图视野范围使定位位置及精度范围视野内可见，默认：false
                        })
                        mapObj.addControl(geolocation)
                        geolocation.getCurrentPosition(function (status, result) {

                        })
                        AMap.event.addListener(geolocation, "complete", (data) => {
                            _that.lat = data.position.lat
                            _that.lng = data.position.lng
                            _that.location = true
                        }
                        );
                        AMap.event.addListener(geolocation, "error", result => {
                            console.log("定位失败")
                            _that.lat = 1.314256;
                            _that.lng = 103.70931;
                        })
                    })
                    // geolocation = (1.314256,103.70931 );
                    return geolocation;
                }
            }

            let geolocation = location.initMap("map-container"); //定位
        },
        find_position() {
            // console.log(this.getLocation());
            this.lat = 1.314256;
            this.lng = 103.70931;
            this.location = true;

        },
        handleRemove(file, fileList) {
            console.log(file, fileList);
        },
        handlePictureCardPreview(file) {
            this.dialogImageUrl = file.url;
            this.dialogVisible = true;
        }
    },

}
</script>


<style scoped>
a {
    text-decoration: none;
    color: white;
}

.container {
    position: absolute;
    width: 100%;
    height: 100%;
    background-color: rgb(238, 241, 246);
}

.main {
    position: relative;
    width: 80%;
    background-color: rgb(255, 255, 255);
    left: 10%;
}

.card-header {
    justify-content: space-between;
    align-items: center;
}

.box-card {
    position: relative;
    width: 60%;
    height: 110%;
    top: 70px;
    left: 21%;
}

.status {
    font-size: large;
    font-weight: bold;
    margin: 10px;
}

.content {
    text-align: left;
    text-indent: 2em;
}

.apply {
    size: 100px;
}

/deep/ .submitBtn {
    position: relative;
    width: 130px;
    height: 50px;
    font-size: 20px;
    top: 50px;
}

.feedback_form {
    padding-top: 60px;
}

.feedback_form p {
    margin-top: 0;
}

.picture {
    position: relative;
    display: inline-block;
    background: rgb(64, 158, 255);
    border: 1px solid #99D3F5;
    border-radius: 4px;
    padding: 10px 12px;
    overflow: hidden;
    color: white;
    text-decoration: none;
    text-indent: 0;
    line-height: 20px;
    height: 18px;
    width: 60px;
}

.picture input {
    position: absolute;
    font-size: 100px;
    right: 0;
    top: 0;
    opacity: 0;
}

.picture:hover {
    background: #AADFFD;
    border-color: rgb(121, 187, 255);
    text-decoration: none;
}
</style>